//+------------------------------------------------------------------+
//|                                          Bollinger %b - Multi.mq4 |
//|                                   based on Bollinger Bands %b.mq4 |
//|                           Original indicator by Alejandro Galindo |
//|                  Modified and Corrected by Linuxser for forex TSD |
//|                  Further modifications made by whitebloodcell     |
//| 
//|  John Bollinger original formula is:                              |
//| (Last - Lower BB)/(Upper BB - Lower BB)                           |
//+-------------------------------------------------------------------+

#property copyright ""
#property link      "www.forex-tsd.com"
//drawing the indicator in the main window
#property indicator_separate_window
//number of indicator buffers
#property indicator_buffers 8
//colors of the indicator
#property indicator_color1 LightSalmon
#property indicator_color2 LightSalmon  
#property indicator_color3 SkyBlue
#property indicator_color4 SkyBlue
#property indicator_color5 LightGreen
#property indicator_color6 LightGreen        
/* 
Choosing of prices to be used for indicator calculations 
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED,
7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 
14-Heiken Ashi Close.) 

Choosing the smoothing algorithm  
0 - JJMA, 1 - JurX, 2 - ParMA, 3 - LRMA, 4 - T3, 5 - SMA, 6 - EMA, 7 - SSMA, 8 - LWMA

Phase is the first smoothing parameter changing within the range between -100 and +100, 
it influences the transient quality; 
*/

//INDICATOR INPUT PARAMETERS 
extern bool   ShowBand1 = TRUE;
extern int    AppliedPrice_1=0;
extern int    Timeframe_1 = 0;    //Note, not currently MTF. Leave as zero to operate on current TF.
extern int    BandMAMethod_1 = 6; 
extern int    BBLength_1=9;
extern int    BBPhase_1 = 100;    
extern double StdDeviation_1=1.9;
extern int    MainLineMAMethod_1=6;
extern int    MainLineMALength_1=2;
extern int    MainLinePhase_1 = 100; 
extern int    SignalMAMethod_1=6;
extern int    SignalLineMALength_1=3;
extern int    SignalLinePhase_1 = 100; 

extern bool   ShowBand2 = TRUE;
extern int    AppliedPrice_2=0;
extern int    Timeframe_2 = 0;    //Note, not currently MTF. Leave as zero to operate on current TF.
extern int    BandMAMethod_2 = 6; 
extern int    BBLength_2=21;
extern int    BBPhase_2 = 100;    
extern double StdDeviation_2=2.0;
extern int    MainLineMAMethod_2=6;
extern int    MainLineMALength_2=2;
extern int    MainLinePhase_2 = 100; 
extern int    SignalMAMethod_2=6;
extern int    SignalLineMALength_2=3;
extern int    SignalLinePhase_2 = 100; 

extern bool   ShowBand3 = TRUE;
extern int    AppliedPrice_3=0;
extern int    Timeframe_3 = 0;    //Note, not currently MTF. Leave as zero to operate on current TF.
extern int    BandMAMethod_3 = 6; 
extern int    BBLength_3=34;
extern int    BBPhase_3 = 100;    
extern double StdDeviation_3=2.0;
extern int    MainLineMAMethod_3=6;
extern int    MainLineMALength_3=2;
extern int    MainLinePhase_3 = 100; 
extern int    SignalMAMethod_3=6;
extern int    SignalLineMALength_3=3;
extern int    SignalLinePhase_3 = 100; 

string sSymbol="";
//---- buffers
double BLG_Buffer_1[];
double MainLineBuffer_1[];
double SignalBuffer_1[];
double MABuffer_1[];
double UpperBandBuffer_1[];
double LowerBandBuffer_1[];

double BLG_Buffer_2[];
double MainLineBuffer_2[];
double SignalBuffer_2[];
double MABuffer_2[];
double UpperBandBuffer_2[];
double LowerBandBuffer_2[];

double BLG_Buffer_3[];
double MainLineBuffer_3[];
double SignalBuffer_3[];
double MABuffer_3[];
double UpperBandBuffer_3[];
double LowerBandBuffer_3[];
//---- variables 
bool   INIT;
int    StartBar, StartBar1, StartBar2;
//+X================================================================X+   
//| SmoothXSeries() function                                         |
//+X================================================================X+    
//----+ Declaring the function SmoothXSeries
//----+ Declaring the function SmoothXSeriesResize 
//----+ Declaring the function SmoothXSeriesAlert   
#include <SmoothXSeries.mqh> 
//+X================================================================X+   
//| PriceSeries() function                                           |
//+X================================================================X+    
//----+ Declaring the function PriceSeries
//----+ Declaring the function PriceSeriesAlert 
#include <PriceSeries.mqh>

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   string short_name;
   sSymbol = Symbol();
   
   //---- Setting the accuracy format (number of digits after the decimal point)
   //---- for the visualization of the indicator values 
   IndicatorDigits(Digits + 1);
   //---- defining buffers for calculation 
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(0,MainLineBuffer_1);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(1,SignalBuffer_1);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(2,MainLineBuffer_2);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(3,SignalBuffer_2);
   SetIndexStyle(4,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(4,MainLineBuffer_3);
   SetIndexStyle(5,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(5,SignalBuffer_3);
   //---- labels for subwindows
   SetIndexLabel(0,StringConcatenate("%B ","(",BBLength_1,",",MainLineMALength_1,",",SignalLineMALength_1,") "," Main"));
   SetIndexLabel(1,StringConcatenate("%B ","(",BBLength_1,",",MainLineMALength_1,",",SignalLineMALength_1,") "," Signal"));
   SetIndexLabel(2,StringConcatenate("%B ","(",BBLength_2,",",MainLineMALength_2,",",SignalLineMALength_2,")"," Main")); 
   SetIndexLabel(3,StringConcatenate("%B ","(",BBLength_2,",",MainLineMALength_2,",",SignalLineMALength_2,") "," Signal"));  
   SetIndexLabel(4,StringConcatenate("%B ","(",BBLength_3,",",MainLineMALength_3,",",SignalLineMALength_3,")"," Main")); 
   SetIndexLabel(5,StringConcatenate("%B ","(",BBLength_3,",",MainLineMALength_3,",",SignalLineMALength_3,") "," Signal")); 
   //--- set levels drawn in indicator window
   SetLevelValue(0,0);
   SetLevelValue(1,5);
   SetLevelValue(2,10);
   SetLevelValue(3,15);
   SetLevelValue(4,20);
   SetLevelValue(5,50);
   SetLevelValue(6,80);
   SetLevelValue(7,85);
   SetLevelValue(8,90);
   SetLevelValue(9,95);
   SetLevelValue(10,100);
   SetLevelStyle(STYLE_DOT,1,DimGray);
 
   //---- setting alerts for not allowed values of external variables
   JJMASeriesAlert (0, "BBLength_1", BBLength_1);
   JJMASeriesAlert (0, "MainLineMALength_1", MainLineMALength_1);
   JJMASeriesAlert (0, "SignalLineMALength_1", SignalLineMALength_1);
   //---- check for invalid phase values
   JJMASeriesAlert (1, "BBPhase_1", BBPhase_1);  
   JJMASeriesAlert (1, "MainLinePhase_1", MainLinePhase_1);  
   JJMASeriesAlert (1, "SignalLinePhase_1", SignalLinePhase_1); 
   //---- setting alerts for not allowed values of external variables
   JJMASeriesAlert (0, "BBLength_2", BBLength_2);
   JJMASeriesAlert (0, "MainLineMALength_2", MainLineMALength_2);
   JJMASeriesAlert (0, "SignalLineMALength_2", SignalLineMALength_2);
   //---- check for invalid phase values
   JJMASeriesAlert (1, "BBPhase_2", BBPhase_2);  
   JJMASeriesAlert (1, "MainLinePhase_2", MainLinePhase_2);  
   JJMASeriesAlert (1, "SignalLinePhase_2", SignalLinePhase_2); 
   //---- setting alerts for not allowed values of external variables
   JJMASeriesAlert (0, "BBLength_3", BBLength_3);
   JJMASeriesAlert (0, "MainLineMALength_3", MainLineMALength_3);
   JJMASeriesAlert (0, "SignalLineMALength_3", SignalLineMALength_3);
   //---- check for invalid phase values
   JJMASeriesAlert (1, "BBPhase_3", BBPhase_3);  
   JJMASeriesAlert (1, "MainLinePhase_3", MainLinePhase_3);  
   JJMASeriesAlert (1, "SignalLinePhase_3", SignalLinePhase_3); 
   
   PriceSeriesAlert(AppliedPrice_1);
   PriceSeriesAlert(AppliedPrice_2); 
   PriceSeriesAlert(AppliedPrice_3);  
   //---- Changing sizes of buffer variables of the function
   //---- SmoothXSeries, number = X(X calls of the SmoothXSeries function)   
   if (SmoothXSeriesResize(9) != 9) {
      INIT = false;
      return(0);
    }

   SetIndexDrawBegin(0,BBLength_1+MainLineMALength_1);
   SetIndexDrawBegin(1,BBLength_1+MainLineMALength_1+SignalLineMALength_1);
   SetIndexDrawBegin(2,BBLength_2+MainLineMALength_2);
   SetIndexDrawBegin(3,BBLength_2+MainLineMALength_2+SignalLineMALength_2);
   SetIndexDrawBegin(4,BBLength_3+MainLineMALength_3);
   SetIndexDrawBegin(5,BBLength_3+MainLineMALength_3+SignalLineMALength_3);

   //Choose shortname based on what options are selected above.
   if(ShowBand1==TRUE && ShowBand2==FALSE && ShowBand3==FALSE) {
      short_name="Bollinger Percent B (%b)("+BBLength_1+","+MainLineMALength_1+SignalLineMALength_1+")";
   }
   else if(ShowBand1==TRUE && ShowBand2==TRUE && ShowBand3==FALSE) {
      short_name="Bollinger Percent B (%b)("+BBLength_1+","+MainLineMALength_1+") ("
      +BBLength_2+","+MainLineMALength_2+","+SignalLineMALength_2+")";
   }
   else if(ShowBand1==TRUE && ShowBand2==TRUE && ShowBand3==TRUE) {
      short_name="Bollinger Percent B (%b)("+BBLength_1+","+MainLineMALength_1+") ("
      +BBLength_2+","+MainLineMALength_2+","+SignalLineMALength_2+") ("+BBLength_3+","
      +MainLineMALength_3+","+SignalLineMALength_3+")";
   }
   IndicatorShortName(short_name); 
   //---- end of initialization
   INIT = true;
 
   return(0);
}
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start() {

   if(ShowBand1==TRUE) {
      if(!INIT || Bars<=BBLength_1) return(0);
      MainFunction(1, sSymbol, BLG_Buffer_1, MainLineBuffer_1, SignalBuffer_1, MABuffer_1, UpperBandBuffer_1, LowerBandBuffer_1,  
                   Timeframe_1, BBLength_1, BandMAMethod_1, BBPhase_1, StdDeviation_1, AppliedPrice_1, MainLineMALength_1, 
                   MainLineMAMethod_1, MainLinePhase_1, SignalLineMALength_1, SignalMAMethod_1, SignalLinePhase_1);
   }                                    
   
   if(ShowBand2==TRUE) {
      if(!INIT || Bars<=BBLength_2) return(0);
      MainFunction(2, sSymbol, BLG_Buffer_2, MainLineBuffer_2, SignalBuffer_2, MABuffer_2, UpperBandBuffer_2, LowerBandBuffer_2, 
                   Timeframe_2, BBLength_2, BandMAMethod_2, BBPhase_2, StdDeviation_2, AppliedPrice_2, MainLineMALength_2, 
                   MainLineMAMethod_2, MainLinePhase_2, SignalLineMALength_2, SignalMAMethod_2, SignalLinePhase_2);
   }            
   if(ShowBand3==TRUE) {
      if(!INIT || Bars<=BBLength_3) return(0);
      MainFunction(3, sSymbol, BLG_Buffer_3, MainLineBuffer_3, SignalBuffer_3, MABuffer_3, UpperBandBuffer_3, LowerBandBuffer_3, 
                   Timeframe_3, BBLength_3, BandMAMethod_3, BBPhase_3, StdDeviation_3, AppliedPrice_3, MainLineMALength_3, 
                   MainLineMAMethod_3, MainLinePhase_3, SignalLineMALength_3, SignalMAMethod_3, SignalLinePhase_3);
   }         
      return(0);
}

//--------------------------------------------------------------------------------
//Function: MainFunction
//Purpose:  Calculate and display position of price relative to the upper and low-
//          er bollinger bands 
//Inputs:   Mode (int) - Calculate either upper or lower band
//          limit (int) - Number of bars to calculate
//          timeframe (int)
//          BandsPeriod (int)
//          MAMethod (int)
//          BandsDeviation (double)
//          AppliedPrice (int)   
//Returns:  
//--------------------------------------------------------------------------------
void MainFunction(int BandNumber, string _Symbol, double &BLGBuffer[], double &MainLineBuffer[], double &SignalBuffer[], double &MABuffer[], 
                  double &UpperBandBuffer[], double &LowerBandBuffer[], int _Timeframe, int BBLength, 
                  int BandMAMethod, int BBPhase, double BandDeviation, int AppliedPrice, int MainLineMALength, int MainLineMAMethod, int MainLinePhase, 
                  int SignalLineMALength, int SignalLineMAMethod, int SignalLinePhase) {
   int i=0,k=0,limit=0,reset;
   double sum,ma,pricevalue;
   double SeriesNumber[3];
   
   switch(BandNumber) {
      case 1: SeriesNumber[0]=0; SeriesNumber[1]=1; SeriesNumber[2]=2; break;
      case 2: SeriesNumber[0]=3; SeriesNumber[1]=4; SeriesNumber[2]=5; break;
      case 3: SeriesNumber[0]=6; SeriesNumber[1]=7; SeriesNumber[2]=8; break;
      default: break;
   }   
   
   if(ArrayRange(BLGBuffer,0) != Bars) {
      ArrayResize(BLGBuffer,Bars);
      ArraySetAsSeries(BLGBuffer, TRUE); 
   }
   if(ArrayRange(MABuffer,0) != Bars) {
      ArrayResize(MABuffer,Bars);
      ArraySetAsSeries(MABuffer, TRUE); 
   }
   if(ArrayRange(UpperBandBuffer,0) != Bars) {
      ArrayResize(UpperBandBuffer,Bars);
      ArraySetAsSeries(UpperBandBuffer, TRUE); 
   }
   if(ArrayRange(LowerBandBuffer,0) != Bars) {
      ArrayResize(LowerBandBuffer,Bars);
      ArraySetAsSeries(LowerBandBuffer, TRUE); 
   }         
   //number of bars already processed by indicator
   int counted_bars=IndicatorCounted();
   int Bars_ = Bars - 1;
   //load empty values into array until enough elements for calculation
   if(counted_bars<1) {
      limit = BBLength+MainLineMALength+SignalLineMALength;
      for (i=0; i<=limit; i++) {
         BLGBuffer[Bars_-i]       = 0;
         MABuffer[Bars_-i]        = 0;
         MainLineBuffer[Bars_-i]  = 0;
         UpperBandBuffer[Bars_-i] = 0;
         LowerBandBuffer[Bars_-i] = 0;
      }         
   }  

   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars_-counted_bars,Bars_-BBLength);
   int MaxBar1 = Bars_-BBLength-1;
   for(i=limit;i>=0;i--) {  
      pricevalue = PriceSeries(AppliedPrice, i);
      ma = SmoothXSeries(SeriesNumber[0], BandMAMethod, 0, MaxBar1, limit, BBPhase, BBLength, pricevalue, i, reset);
      for(sum = 0.0, k = 0; k < BBLength; k++) {
          sum += ((iClose(_Symbol,_Timeframe,k+i)-ma)*(iClose(_Symbol,_Timeframe,k+i)-ma));
      }    
      if(reset != 0) return(-1);
      //calculate the moving average value
      //ma = iMA(NULL,_Timeframe,BBLength,0,BandMAMethod,AppliedPrice,i);
      //      for(sum = 0.0, k = 0; k < BBLength; k++) {
      //         sum += ((iClose(_Symbol,_Timeframe,k+i)-ma)*(iClose(_Symbol,_Timeframe,k+i)-ma));
      //      }     
      //do I need this?
      //MABuffer[i] = ma;
      //calculate upper and lower deviations from moving average
      if (BandDeviation!=0) {
            UpperBandBuffer[i]  = ma+BandDeviation*MathSqrt(sum/BBLength);
            LowerBandBuffer[i]  = ma-BandDeviation*MathSqrt(sum/BBLength);
      }//if (BandDeviation!=0)               
      
      BLGBuffer[i]=((iClose(_Symbol,_Timeframe,i)-LowerBandBuffer[i])/
                    (UpperBandBuffer[i]-LowerBandBuffer[i]))*100;
      
      //(Last - Lower BB)/(Upper BB - Lower BB)      
      //BLGBuffer[i]=((Close[i] - iBands(NULL,_Timeframe,BBPeriod,BandDeviation,0,AppliedPrice,MODE_LOWER,i))/
      //(iBands(NULL,timefame,BBPeriod,BandDeviation,0,AppliedPrice,MODE_UPPER,i)-iBands(NULL,timefame,BBPeriod,BandDeviation,0,AppliedPrice,MODE_LOWER,i)))*100;
   }//end for(i=limit;i>=0;i--)
   
  //---- Call of the SmoothXSeries function number 0, 
  //---- Parameters Phase and Length are not changed at each bar (din = 0)
  int MaxBar2 = Bars_-BBLength-MainLineMALength;
  int MaxBar3 = Bars_-BBLength-MainLineMALength-SignalLineMALength;
  for (i = limit; i >= 0; i--) {
     MainLineBuffer[i] = SmoothXSeries(SeriesNumber[1], MainLineMAMethod, 0, MaxBar2, limit, MainLinePhase, MainLineMALength, BLGBuffer[i], i, reset);
     if(reset != 0) return(-1);
     //if(i < MaxBar2) {
        SignalBuffer[i] = SmoothXSeries(SeriesNumber[2], SignalLineMAMethod, 0, MaxBar3, limit, SignalLinePhase, SignalLineMALength, MainLineBuffer[i], i, reset);
        if(reset != 0) return(-1);  
    // }
      
  }   
}//end MainFunction()   







